# generated by datamodel-codegen:
#   filename:  data_science_data_room.json

from __future__ import annotations

from typing import Optional, Sequence, Union

from typing_extensions import Literal, NotRequired, TypedDict


class AnalystPermission(TypedDict):
    nodeId: str


class AwsConfig(TypedDict):
    bucket: str
    objectKey: NotRequired[Optional[str]]
    region: str


ColumnDataType = Literal['integer', 'float', 'string']


class ColumnTuple(TypedDict):
    columns: Sequence[int]


class CredentialsDependencyV9(TypedDict):
    user: str


CredentialsDependencyV92 = Union[Literal['splickyDsp'], CredentialsDependencyV9]


class DataOwnerPermission(AnalystPermission):
    pass


class DatasetSinkEncryptionKeyDependency(TypedDict):
    dependency: str
    isKeyHexEncoded: bool


class EnclaveSpecification(TypedDict):
    attestationProtoBase64: str
    id: str
    workerProtocol: int


class ExportConnectorKind(TypedDict):
    aws: AwsConfig


ExportConnectorKind3 = ExportConnectorKind


class ExportConnectorKind2(ExportConnectorKind):
    pass


class ExportConnectorKind26(TypedDict):
    azure: Sequence


class ExportType4(TypedDict):
    raw: Sequence


class ExportType5(TypedDict):
    zipSingleFile: str


class ExportType6(TypedDict):
    zipAllFiles: Sequence


ExportType = Union[ExportType4, ExportType5, ExportType6]


FormatType = Literal[
    'STRING',
    'INTEGER',
    'FLOAT',
    'EMAIL',
    'DATE_ISO8601',
    'PHONE_NUMBER_E164',
    'HASH_SHA256_HEX',
]


class GcsConfig(TypedDict):
    bucket: str
    objectKey: NotRequired[Optional[str]]


HashingAlgorithm = Literal['SHA256_HEX']


class ImportConnectorKind(ExportConnectorKind):
    pass


ImportConnectorKind3 = ImportConnectorKind


class ImportConnectorKind2(ExportConnectorKind):
    pass


class ImportConnectorKind26(ExportConnectorKind26):
    pass


class ImportConnectorKind27(TypedDict):
    gcs: GcsConfig


ImportConnectorKind24 = Union[
    ImportConnectorKind2, ImportConnectorKind26, ImportConnectorKind27
]


class ImportConnectorNode(TypedDict):
    credentialsDependency: str
    kind: ImportConnectorKind3
    specificationId: str


class ImportConnectorNodeV9(TypedDict):
    credentialsDependency: str
    kind: ImportConnectorKind24
    specificationId: str


class InputDataType3(ExportType4):
    pass


class ManagerPermission(TypedDict):
    pass


MaskType = Literal[
    'genericString',
    'genericNumber',
    'name',
    'address',
    'postcode',
    'phoneNumber',
    'socialSecurityNumber',
    'email',
    'date',
    'timestamp',
    'iban',
]


class MatchingComputationNode(TypedDict):
    config: str
    dependencies: Sequence[str]
    enableLogsOnError: bool
    enableLogsOnSuccess: bool
    output: str
    specificationId: str
    staticContentSpecificationId: str


class NumRowsValidationRule(TypedDict):
    atLeast: NotRequired[Optional[int]]
    atMost: NotRequired[Optional[int]]


class NumericRangeRule(TypedDict):
    greaterThan: NotRequired[Optional[float]]
    greaterThanEquals: NotRequired[Optional[float]]
    lessThan: NotRequired[Optional[float]]
    lessThanEquals: NotRequired[Optional[float]]


class ParticipantPermission1(TypedDict):
    dataOwner: DataOwnerPermission


class ParticipantPermission2(TypedDict):
    analyst: AnalystPermission


class ParticipantPermission3(TypedDict):
    manager: ManagerPermission


ParticipantPermission = Union[
    ParticipantPermission1, ParticipantPermission2, ParticipantPermission3
]


class PostComputationNode(TypedDict):
    dependency: str
    specificationId: str
    useMockBackend: bool


class PreviewComputationNode(TypedDict):
    dependency: str
    quotaBytes: int


class PythonEnvironmentComputationNode(TypedDict):
    extraChunkCacheSizeToAvailableMemoryRatio: NotRequired[Optional[float]]
    minimumContainerMemorySize: NotRequired[Optional[int]]
    requirementsTxtContent: str
    scriptingSpecificationId: str
    staticContentSpecificationId: str


class PythonOptions(TypedDict):
    customVirtualEnvironmentId: NotRequired[Optional[str]]


class RawLeafNode(ManagerPermission):
    pass


S3Provider = Literal['Aws', 'Gcs']


class S3SinkComputationNode(TypedDict):
    credentialsDependencyId: str
    endpoint: str
    region: NotRequired[str]
    s3Provider: NotRequired[S3Provider]
    specificationId: str
    uploadDependencyId: str


class Script(TypedDict):
    content: str
    name: str


ScriptingLanguage = Literal['python', 'r']


class ScriptingLanguageV92(TypedDict):
    python: PythonOptions


ScriptingLanguageV9 = Union[Literal['r'], ScriptingLanguageV92]


class SqlNodePrivacyFilter(TypedDict):
    minimumRowsCount: int


class TableMapping(TypedDict):
    nodeId: str
    tableName: str


class UniquenessValidationRule(TypedDict):
    uniqueKeys: Sequence[ColumnTuple]


class ZipInputDataType3(TypedDict):
    all: Sequence


class ZipInputDataType4(TypedDict):
    files: Sequence[str]


ZipInputDataType = Union[ZipInputDataType3, ZipInputDataType4]


class ColumnDataFormat(TypedDict):
    dataType: ColumnDataType
    isNullable: bool


class ColumnValidationV0(TypedDict):
    allowNull: bool
    formatType: FormatType
    hashWith: NotRequired[Optional[HashingAlgorithm]]
    inRange: NotRequired[Optional[NumericRangeRule]]
    name: NotRequired[Optional[str]]


class ComputationNodeKind9(TypedDict):
    s3Sink: S3SinkComputationNode


class ComputationNodeKind10(TypedDict):
    match: MatchingComputationNode


class ComputationNodeKindV2(ComputationNodeKind9):
    pass


class ComputationNodeKindV214(ComputationNodeKind10):
    pass


class ComputationNodeKindV215(TypedDict):
    post: PostComputationNode


class ComputationNodeKindV6(ComputationNodeKind9):
    pass


class ComputationNodeKindV618(ComputationNodeKind10):
    pass


class ComputationNodeKindV619(ComputationNodeKindV215):
    pass


class ComputationNodeKindV620(TypedDict):
    preview: PreviewComputationNode


class ComputationNodeKindV621(TypedDict):
    importConnector: ImportConnectorNode


class ComputationNodeKindV9(ComputationNodeKind9):
    pass


class ComputationNodeKindV919(ComputationNodeKind10):
    pass


class ComputationNodeKindV920(ComputationNodeKindV215):
    pass


class ComputationNodeKindV921(ComputationNodeKindV620):
    pass


class ComputationNodeKindV922(TypedDict):
    importConnector: ImportConnectorNodeV9


class EnvironmentComputationNodeKind2(TypedDict):
    python: PythonEnvironmentComputationNode


EnvironmentComputationNodeKind = EnvironmentComputationNodeKind2


class ExportConnectorKind27(ImportConnectorKind27):
    pass


ExportConnectorKind24 = Union[
    ExportConnectorKind2, ExportConnectorKind26, ExportConnectorKind27
]


class ExportNodeDependency(TypedDict):
    exportType: ExportType
    name: str


class InputDataType4(TypedDict):
    zip: ZipInputDataType


InputDataType = Union[InputDataType3, InputDataType4]


class LeafNodeKind3(TypedDict):
    raw: RawLeafNode


class LeafNodeKindV2(LeafNodeKind3):
    pass


class Participant(TypedDict):
    permissions: Sequence[ParticipantPermission]
    user: str


class ScriptingComputationNode(TypedDict):
    additionalScripts: Sequence[Script]
    dependencies: Sequence[str]
    enableLogsOnError: bool
    enableLogsOnSuccess: bool
    extraChunkCacheSizeToAvailableMemoryRatio: NotRequired[Optional[float]]
    mainScript: Script
    minimumContainerMemorySize: NotRequired[Optional[int]]
    output: str
    scriptingLanguage: ScriptingLanguage
    scriptingSpecificationId: str
    staticContentSpecificationId: str


class ScriptingComputationNodeV9(TypedDict):
    additionalScripts: Sequence[Script]
    dependencies: Sequence[str]
    enableLogsOnError: bool
    enableLogsOnSuccess: bool
    extraChunkCacheSizeToAvailableMemoryRatio: NotRequired[Optional[float]]
    mainScript: Script
    minimumContainerMemorySize: NotRequired[Optional[int]]
    output: str
    scriptingLanguage: ScriptingLanguageV9
    scriptingSpecificationId: str
    staticContentSpecificationId: str


class SqlComputationNode(TypedDict):
    dependencies: Sequence[TableMapping]
    privacyFilter: NotRequired[Optional[SqlNodePrivacyFilter]]
    specificationId: str
    statement: str


class SqliteComputationNode(TypedDict):
    dependencies: Sequence[TableMapping]
    enableLogsOnError: bool
    enableLogsOnSuccess: bool
    sqliteSpecificationId: str
    statement: str
    staticContentSpecificationId: str


class SyntheticNodeColumn(TypedDict):
    dataFormat: ColumnDataFormat
    index: int
    maskType: MaskType
    name: NotRequired[Optional[str]]
    shouldMaskColumn: bool


class TableLeafNodeColumn(TypedDict):
    dataFormat: ColumnDataFormat
    name: str


class TableLeafNodeColumnV2(TypedDict):
    dataFormat: ColumnDataFormat
    name: str
    validation: ColumnValidationV0


class TableValidationV0(TypedDict):
    allowEmpty: NotRequired[Optional[bool]]
    numRows: NotRequired[Optional[NumRowsValidationRule]]
    uniqueness: NotRequired[Optional[UniquenessValidationRule]]


class ValidationNodeV2(TypedDict):
    dropInvalidRows: NotRequired[Optional[bool]]
    pythonSpecificationId: str
    staticContentSpecificationId: str
    validation: TableValidationV0


class ComputationNodeKind6(TypedDict):
    sql: SqlComputationNode


class ComputationNodeKind7(TypedDict):
    scripting: ScriptingComputationNode


class ComputationNodeKindV29(ComputationNodeKind6):
    pass


class ComputationNodeKindV210(TypedDict):
    sqlite: SqliteComputationNode


class ComputationNodeKindV211(ComputationNodeKind7):
    pass


class ComputationNodeKindV613(ComputationNodeKind6):
    pass


class ComputationNodeKindV614(ComputationNodeKindV210):
    pass


class ComputationNodeKindV615(ComputationNodeKind7):
    pass


class ComputationNodeKindV914(ComputationNodeKind6):
    pass


class ComputationNodeKindV915(ComputationNodeKindV210):
    pass


class ComputationNodeKindV916(TypedDict):
    scripting: ScriptingComputationNodeV9


class DatasetSinkInput(TypedDict):
    datasetName: str
    dependency: str
    inputDataType: InputDataType


class EnvironmentComputationNode(TypedDict):
    kind: EnvironmentComputationNodeKind


class ExportConnectorNode(TypedDict):
    credentialsDependency: str
    dependency: ExportNodeDependency
    kind: ExportConnectorKind3
    specificationId: str


class ExportConnectorNodeV9(TypedDict):
    credentialsDependency: CredentialsDependencyV92
    dependency: ExportNodeDependency
    kind: ExportConnectorKind24
    specificationId: str


class SyntheticDataComputationNode(TypedDict):
    columns: Sequence[SyntheticNodeColumn]
    dependency: str
    enableLogsOnError: bool
    enableLogsOnSuccess: bool
    epsilon: float
    outputOriginalDataStatistics: bool
    staticContentSpecificationId: str
    synthSpecificationId: str


class TableLeafNode(TypedDict):
    columns: Sequence[TableLeafNodeColumn]
    sqlSpecificationId: str


class TableLeafNodeV2(TypedDict):
    columns: Sequence[TableLeafNodeColumnV2]
    validationNode: ValidationNodeV2


class ComputationNodeKind8(TypedDict):
    syntheticData: SyntheticDataComputationNode


ComputationNodeKind = Union[
    ComputationNodeKind6,
    ComputationNodeKind7,
    ComputationNodeKind8,
    ComputationNodeKind9,
    ComputationNodeKind10,
]


class ComputationNodeKindV212(ComputationNodeKind8):
    pass


ComputationNodeKindV28 = Union[
    ComputationNodeKindV29,
    ComputationNodeKindV210,
    ComputationNodeKindV211,
    ComputationNodeKindV212,
    ComputationNodeKindV2,
    ComputationNodeKindV214,
    ComputationNodeKindV215,
]


class ComputationNodeKindV616(ComputationNodeKind8):
    pass


class ComputationNodeKindV622(TypedDict):
    exportConnector: ExportConnectorNode


class ComputationNodeKindV917(ComputationNodeKind8):
    pass


class ComputationNodeKindV923(TypedDict):
    exportConnector: ExportConnectorNodeV9


class ComputationNodeKindV925(TypedDict):
    environment: EnvironmentComputationNode


class ComputationNodeV2(TypedDict):
    kind: ComputationNodeKindV28


class DatasetSinkComputationNode(TypedDict):
    datasetImportId: NotRequired[Optional[str]]
    encryptionKeyDependency: DatasetSinkEncryptionKeyDependency
    input: DatasetSinkInput
    specificationId: str


class LeafNodeKind4(TypedDict):
    table: TableLeafNode


LeafNodeKind = Union[LeafNodeKind3, LeafNodeKind4]


class LeafNodeKindV25(TypedDict):
    table: TableLeafNodeV2


LeafNodeKindV23 = Union[LeafNodeKindV2, LeafNodeKindV25]


class LeafNodeV2(TypedDict):
    isRequired: bool
    kind: LeafNodeKindV23


class NodeKindV2(TypedDict):
    leaf: LeafNodeV2


class NodeKindV25(TypedDict):
    computation: ComputationNodeV2


NodeKindV23 = Union[NodeKindV2, NodeKindV25]


class NodeKindV6(NodeKindV2):
    pass


class NodeKindV9(NodeKindV2):
    pass


class NodeV2(TypedDict):
    id: str
    kind: NodeKindV23
    name: str


class AddComputationCommitV2(TypedDict):
    analysts: Sequence[str]
    enclaveSpecifications: Sequence[EnclaveSpecification]
    node: NodeV2


class ComputationNode(TypedDict):
    kind: ComputationNodeKind


class ComputationNodeKindV623(TypedDict):
    datasetSink: DatasetSinkComputationNode


ComputationNodeKindV612 = Union[
    ComputationNodeKindV613,
    ComputationNodeKindV614,
    ComputationNodeKindV615,
    ComputationNodeKindV616,
    ComputationNodeKindV6,
    ComputationNodeKindV618,
    ComputationNodeKindV619,
    ComputationNodeKindV620,
    ComputationNodeKindV621,
    ComputationNodeKindV622,
    ComputationNodeKindV623,
]


class ComputationNodeKindV924(ComputationNodeKindV623):
    pass


ComputationNodeKindV913 = Union[
    ComputationNodeKindV914,
    ComputationNodeKindV915,
    ComputationNodeKindV916,
    ComputationNodeKindV917,
    ComputationNodeKindV9,
    ComputationNodeKindV919,
    ComputationNodeKindV920,
    ComputationNodeKindV921,
    ComputationNodeKindV922,
    ComputationNodeKindV923,
    ComputationNodeKindV924,
    ComputationNodeKindV925,
]


class ComputationNodeV6(TypedDict):
    kind: ComputationNodeKindV612


class ComputationNodeV9(TypedDict):
    kind: ComputationNodeKindV913


class DataScienceCommitKindV2(TypedDict):
    addComputation: AddComputationCommitV2


DataScienceCommitKindV22 = DataScienceCommitKindV2


class DataScienceCommitV2(TypedDict):
    enclaveDataRoomId: str
    historyPin: str
    id: str
    kind: DataScienceCommitKindV22
    name: str


class DataScienceCommitV3(DataScienceCommitV2):
    pass


class DataScienceCommitV4(DataScienceCommitV2):
    pass


class DataScienceCommitV5(DataScienceCommitV2):
    pass


class DataScienceDataRoomConfigurationV2(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableDevelopment: bool
    enablePostWorker: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV2]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomConfigurationV3(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableDevelopment: bool
    enablePostWorker: bool
    enableSafePythonWorkerStacktrace: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV2]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomConfigurationV4(DataScienceDataRoomConfigurationV3):
    pass


class DataScienceDataRoomConfigurationV5(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableAllowEmptyFilesInValidation: bool
    enableDevelopment: bool
    enablePostWorker: bool
    enableSafePythonWorkerStacktrace: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV2]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomV21(TypedDict):
    static: DataScienceDataRoomConfigurationV2


class DataScienceDataRoomV31(TypedDict):
    static: DataScienceDataRoomConfigurationV3


class DataScienceDataRoomV41(TypedDict):
    static: DataScienceDataRoomConfigurationV4


class DataScienceDataRoomV51(TypedDict):
    static: DataScienceDataRoomConfigurationV5


class InteractiveDataScienceDataRoomV2(TypedDict):
    commits: Sequence[DataScienceCommitV2]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV2


class InteractiveDataScienceDataRoomV3(TypedDict):
    commits: Sequence[DataScienceCommitV3]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV3


class InteractiveDataScienceDataRoomV4(TypedDict):
    commits: Sequence[DataScienceCommitV4]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV4


class InteractiveDataScienceDataRoomV5(TypedDict):
    commits: Sequence[DataScienceCommitV5]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV5


class LeafNode(TypedDict):
    isRequired: bool
    kind: LeafNodeKind


class NodeKind3(TypedDict):
    leaf: LeafNode


class NodeKind4(TypedDict):
    computation: ComputationNode


NodeKind = Union[NodeKind3, NodeKind4]


class NodeKindV65(TypedDict):
    computation: ComputationNodeV6


NodeKindV63 = Union[NodeKindV6, NodeKindV65]


class NodeKindV95(TypedDict):
    computation: ComputationNodeV9


NodeKindV93 = Union[NodeKindV9, NodeKindV95]


class NodeV6(TypedDict):
    id: str
    kind: NodeKindV63
    name: str


class NodeV9(TypedDict):
    id: str
    kind: NodeKindV93
    name: str


class AddComputationCommitV6(TypedDict):
    analysts: Sequence[str]
    enclaveSpecifications: Sequence[EnclaveSpecification]
    node: NodeV6


class AddComputationCommitV9(TypedDict):
    analysts: Sequence[str]
    enclaveSpecifications: Sequence[EnclaveSpecification]
    node: NodeV9


class DataScienceCommitKindV6(TypedDict):
    addComputation: AddComputationCommitV6


DataScienceCommitKindV62 = DataScienceCommitKindV6


class DataScienceCommitKindV9(TypedDict):
    addComputation: AddComputationCommitV9


DataScienceCommitKindV92 = DataScienceCommitKindV9


class DataScienceCommitV10(TypedDict):
    enclaveDataRoomId: str
    historyPin: str
    id: str
    kind: DataScienceCommitKindV92
    name: str


class DataScienceCommitV11(DataScienceCommitV10):
    pass


class DataScienceCommitV12(DataScienceCommitV10):
    pass


class DataScienceCommitV6(TypedDict):
    enclaveDataRoomId: str
    historyPin: str
    id: str
    kind: DataScienceCommitKindV62
    name: str


class DataScienceCommitV7(DataScienceCommitV6):
    pass


class DataScienceCommitV8(DataScienceCommitV6):
    pass


class DataScienceCommitV9(DataScienceCommitV10):
    pass


class DataScienceDataRoomConfigurationV10(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableAirlock: bool
    enableAllowEmptyFilesInValidation: bool
    enableDevelopment: bool
    enableForceSparkValidation: NotRequired[bool]
    enablePostWorker: bool
    enableSafePythonWorkerStacktrace: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV9]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomConfigurationV11(DataScienceDataRoomConfigurationV10):
    pass


class DataScienceDataRoomConfigurationV12(DataScienceDataRoomConfigurationV10):
    pass


class DataScienceDataRoomConfigurationV6(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableAirlock: bool
    enableAllowEmptyFilesInValidation: bool
    enableDevelopment: bool
    enablePostWorker: bool
    enableSafePythonWorkerStacktrace: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV6]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomConfigurationV7(DataScienceDataRoomConfigurationV6):
    pass


class DataScienceDataRoomConfigurationV8(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableAirlock: bool
    enableAllowEmptyFilesInValidation: bool
    enableDevelopment: bool
    enableForceSparkValidation: NotRequired[bool]
    enablePostWorker: bool
    enableSafePythonWorkerStacktrace: bool
    enableServersideWasmValidation: bool
    enableSqliteWorker: bool
    enableTestDatasets: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[NodeV6]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomConfigurationV9(DataScienceDataRoomConfigurationV10):
    pass


class DataScienceDataRoomV101(TypedDict):
    static: DataScienceDataRoomConfigurationV10


class DataScienceDataRoomV111(TypedDict):
    static: DataScienceDataRoomConfigurationV11


class DataScienceDataRoomV121(TypedDict):
    static: DataScienceDataRoomConfigurationV12


class DataScienceDataRoomV22(TypedDict):
    interactive: InteractiveDataScienceDataRoomV2


DataScienceDataRoomV2 = Union[DataScienceDataRoomV21, DataScienceDataRoomV22]


class DataScienceDataRoomV32(TypedDict):
    interactive: InteractiveDataScienceDataRoomV3


DataScienceDataRoomV3 = Union[DataScienceDataRoomV31, DataScienceDataRoomV32]


class DataScienceDataRoomV42(TypedDict):
    interactive: InteractiveDataScienceDataRoomV4


DataScienceDataRoomV4 = Union[DataScienceDataRoomV41, DataScienceDataRoomV42]


class DataScienceDataRoomV52(TypedDict):
    interactive: InteractiveDataScienceDataRoomV5


DataScienceDataRoomV5 = Union[DataScienceDataRoomV51, DataScienceDataRoomV52]


class DataScienceDataRoomV61(TypedDict):
    static: DataScienceDataRoomConfigurationV6


class DataScienceDataRoomV71(TypedDict):
    static: DataScienceDataRoomConfigurationV7


class DataScienceDataRoomV81(TypedDict):
    static: DataScienceDataRoomConfigurationV8


class DataScienceDataRoomV91(TypedDict):
    static: DataScienceDataRoomConfigurationV9


class InteractiveDataScienceDataRoomV10(TypedDict):
    commits: Sequence[DataScienceCommitV10]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV10


class InteractiveDataScienceDataRoomV11(TypedDict):
    commits: Sequence[DataScienceCommitV11]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV11


class InteractiveDataScienceDataRoomV12(TypedDict):
    commits: Sequence[DataScienceCommitV12]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV12


class InteractiveDataScienceDataRoomV6(TypedDict):
    commits: Sequence[DataScienceCommitV6]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV6


class InteractiveDataScienceDataRoomV7(TypedDict):
    commits: Sequence[DataScienceCommitV7]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV7


class InteractiveDataScienceDataRoomV8(TypedDict):
    commits: Sequence[DataScienceCommitV8]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV8


class InteractiveDataScienceDataRoomV9(TypedDict):
    commits: Sequence[DataScienceCommitV9]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfigurationV9


class Node(TypedDict):
    id: str
    kind: NodeKind
    name: str


class DataScienceDataRoom3(TypedDict):
    v2: DataScienceDataRoomV2


class DataScienceDataRoom4(TypedDict):
    v3: DataScienceDataRoomV3


class DataScienceDataRoom5(TypedDict):
    v4: DataScienceDataRoomV4


class DataScienceDataRoom6(TypedDict):
    v5: DataScienceDataRoomV5


class AddComputationCommit(TypedDict):
    analysts: Sequence[str]
    enclaveSpecifications: Sequence[EnclaveSpecification]
    node: Node


class DataScienceCommitKind(TypedDict):
    addComputation: AddComputationCommit


DataScienceCommitKind2 = DataScienceCommitKind


class DataScienceCommitV0(TypedDict):
    enclaveDataRoomId: str
    historyPin: str
    id: str
    kind: DataScienceCommitKind2
    name: str


class DataScienceCommitV1(DataScienceCommitV0):
    pass


class DataScienceDataRoomConfiguration(TypedDict):
    dcrSecretIdBase64: NotRequired[Optional[str]]
    description: str
    enableDevelopment: bool
    enclaveRootCertificatePem: str
    enclaveSpecifications: Sequence[EnclaveSpecification]
    id: str
    nodes: Sequence[Node]
    participants: Sequence[Participant]
    title: str


class DataScienceDataRoomV01(TypedDict):
    static: DataScienceDataRoomConfiguration


class DataScienceDataRoomV13(DataScienceDataRoomV01):
    pass


class DataScienceDataRoomV102(TypedDict):
    interactive: InteractiveDataScienceDataRoomV10


DataScienceDataRoomV10 = Union[DataScienceDataRoomV101, DataScienceDataRoomV102]


class DataScienceDataRoomV112(TypedDict):
    interactive: InteractiveDataScienceDataRoomV11


DataScienceDataRoomV11 = Union[DataScienceDataRoomV111, DataScienceDataRoomV112]


class DataScienceDataRoomV122(TypedDict):
    interactive: InteractiveDataScienceDataRoomV12


DataScienceDataRoomV12 = Union[DataScienceDataRoomV121, DataScienceDataRoomV122]


class DataScienceDataRoomV62(TypedDict):
    interactive: InteractiveDataScienceDataRoomV6


DataScienceDataRoomV6 = Union[DataScienceDataRoomV61, DataScienceDataRoomV62]


class DataScienceDataRoomV72(TypedDict):
    interactive: InteractiveDataScienceDataRoomV7


DataScienceDataRoomV7 = Union[DataScienceDataRoomV71, DataScienceDataRoomV72]


class DataScienceDataRoomV82(TypedDict):
    interactive: InteractiveDataScienceDataRoomV8


DataScienceDataRoomV8 = Union[DataScienceDataRoomV81, DataScienceDataRoomV82]


class DataScienceDataRoomV92(TypedDict):
    interactive: InteractiveDataScienceDataRoomV9


DataScienceDataRoomV9 = Union[DataScienceDataRoomV91, DataScienceDataRoomV92]


class InteractiveDataScienceDataRoomV0(TypedDict):
    commits: Sequence[DataScienceCommitV0]
    initialConfiguration: DataScienceDataRoomConfiguration


class InteractiveDataScienceDataRoomV1(TypedDict):
    commits: Sequence[DataScienceCommitV1]
    enableAutomergeFeature: bool
    initialConfiguration: DataScienceDataRoomConfiguration


class DataScienceDataRoom7(TypedDict):
    v6: DataScienceDataRoomV6


class DataScienceDataRoom8(TypedDict):
    v7: DataScienceDataRoomV7


class DataScienceDataRoom9(TypedDict):
    v8: DataScienceDataRoomV8


class DataScienceDataRoom10(TypedDict):
    v9: DataScienceDataRoomV9


class DataScienceDataRoom11(TypedDict):
    v10: DataScienceDataRoomV10


class DataScienceDataRoom12(TypedDict):
    v11: DataScienceDataRoomV11


class DataScienceDataRoom13(TypedDict):
    v12: DataScienceDataRoomV12


class DataScienceDataRoomV02(TypedDict):
    interactive: InteractiveDataScienceDataRoomV0


DataScienceDataRoomV0 = Union[DataScienceDataRoomV01, DataScienceDataRoomV02]


class DataScienceDataRoomV14(TypedDict):
    interactive: InteractiveDataScienceDataRoomV1


DataScienceDataRoomV1 = Union[DataScienceDataRoomV13, DataScienceDataRoomV14]


class DataScienceDataRoom1(TypedDict):
    v0: DataScienceDataRoomV0


class DataScienceDataRoom2(TypedDict):
    v1: DataScienceDataRoomV1


DataScienceDataRoom = Union[
    DataScienceDataRoom1,
    DataScienceDataRoom2,
    DataScienceDataRoom3,
    DataScienceDataRoom4,
    DataScienceDataRoom5,
    DataScienceDataRoom6,
    DataScienceDataRoom7,
    DataScienceDataRoom8,
    DataScienceDataRoom9,
    DataScienceDataRoom10,
    DataScienceDataRoom11,
    DataScienceDataRoom12,
    DataScienceDataRoom13,
]
